GEGELATI

Loading...
Searching...
No Matches
Public Member Functions | Protected Attributes | List of all members
TPG::TPGActionEdge Class Reference

Class representing ActionEdges of the Tangled Program Graphs. More...

`#include <tpgActionEdge.h>`

Inheritance diagram for TPG::TPGActionEdge:

## Public Member Functions
| TPGActionEdge (const TPGVertex *src, const std::shared_ptr< Program::Program > prog, uint64_t actClass)
| Main constructor of the TPGEdge class.
const TPGVertex * | getDestination () const override
| Override of the tpgEdge function because there should not be destination to action edge.
void | setDestination (TPGVertex *newDestination) override
| Override of the tpgEdge function because there should not be destination to action edge.
void | setActionClass (uint64_t newActionClass)
| set a new action class
uint64_t | getActionClass () const
| get the action class
| TPGActionEdge ()=delete
| Delete the default constructor.
Public Member Functions inherited from TPG::TPGEdge
virtual | ~TPGEdge ()=default
| Default virtual destructor (for polymorphism)
| TPGEdge (const TPGVertex *src, const TPGVertex *dest, const std::shared_ptr< Program::Program > prog)
| Main constructor of the TPGEdge class.
Program::Program & | getProgram () const
| Get a const reference to the Program of the TPGEdge.
void | setProgram (const std::shared_ptr< Program::Program > prog) const
| Set a new Program for the TPGEdge.
std::shared_ptr< Program::Program > | getProgramSharedPointer ()
| Get the shared_pointer to the Program.
const TPGVertex * | getSource () const
| Get the source TPGVertex of the TPGEdge.
void | setSource (TPGVertex *newSource)
| Set a new source TPGVertex to the TPGEdge.
virtual uint64_t | getEdgeID () const
| Get the unique identifier of the TPGEdge.
virtual void | setEdgeID (uint64_t newID)
| Set a new unique identifier to the TPGEdge.

## Protected Attributes
uint64_t | actionClass
| action class of the edge
Protected Attributes inherited from TPG::TPGEdge
const TPGVertex * | source
| Pointer to the source TPGVertex of this TPGEdge.
const TPGVertex * | destination
| Pointer to the destination TPGVertex of this TPGEdge.
std::shared_ptr< Program::Program > | program
uint64_t | edgeID
| Unique identifier of the TPGEdge.

## Additional Inherited Members
Static Public Member Functions inherited from TPG::TPGEdge
static uint64_t | getEdgeIDCounter ()
| Get the current value of the edge ID counter.
Protected Member Functions inherited from TPG::TPGEdge
| TPGEdge ()=delete
| Delete the default constructor.
Static Protected Member Functions inherited from TPG::TPGEdge
static uint64_t | incrementeCounter ()
| Incremente the edge ID counter and return the new value.
static void | resetEdgeIDCounter ()
| Reset the edge ID counter.

## Detailed Description

Class representing ActionEdges of the Tangled Program Graphs.

The source of an TPGActionEdge can not be a TPGTeam, only a TPGAction. A TPGActionEdge does not have a destination.

It also has an action class corresponding to the continuous actions class it is assessing. This action class is only used for multi-action program cases.

## Constructor & Destructor Documentation

## ◆ TPGActionEdge()

TPG::TPGActionEdge::TPGActionEdge | ( | const TPGVertex * | src,
|  | const std::shared_ptr< Program::Program > | prog,
|  | uint64_t | actClass )
| inline

Main constructor of the TPGEdge class.

This constructor does not register the created TPGEdge in the list of incoming or outgoing edges of the given TPGVertex.

Parameters

  [in] | src | pointer to the source TPGVertex of the edge.
  [in] | prog | the shared pointer to the Program associated to the
  [in] | actClass | actionClass of the TPGActionEdge edge.

## Member Function Documentation

## ◆ getDestination()

const TPG::TPGVertex * TPG::TPGActionEdge::getDestination | ( |  | ) | const
| override virtual

Override of the tpgEdge function because there should not be destination to action edge.

Copyright or © or Copr. IETR/INSA - Rennes (2019 - 2025) :

Karol Desnos kdesn.nosp@m.os@i.nosp@m.nsa-r.nosp@m.enne.nosp@m.s.fr (2019) Quentin Vacher qvach.nosp@m.er@i.nosp@m.nsa-r.nosp@m.enne.nosp@m.s.fr (2025)

GEGELATI is an open-source reinforcement learning framework for training artificial intelligence based on Tangled Program Graphs (TPGs).

This software is governed by the CeCILL-C license under French law and abiding by the rules of distribution of free software. You can use, modify and/ or redistribute the software under the terms of the CeCILL-C license as circulated by CEA, CNRS and INRIA at the following URL "http://www.cecill.info".

As a counterpart to the access to the source code and rights to copy, modify and redistribute granted by the license, users are provided only with a limited warranty and the software's author, the holder of the economic rights, and the successive licensors have only limited liability.

In this respect, the user's attention is drawn to the risks associated with loading, using, modifying and/or developing or reproducing the software by the user in light of its specific status of free software, that may mean that it is complicated to manipulate, and that also therefore means that it is reserved for developers and experienced professionals having in-depth computer knowledge. Users are therefore encouraged to load and test the software's suitability as regards their requirements in conditions enabling the security of their systems and/or data to be ensured and, more generally, to use and operate it in the same conditions as regards security.

The fact that you are presently reading this means that you have had knowledge of the CeCILL-C license and that you accept its terms.

Reimplemented from TPG::TPGEdge.

## ◆ setActionClass()

void TPG::TPGActionEdge::setActionClass | ( | uint64_t | newActionClass | ) |

set a new action class

Parameters

  [in] | newActionClass | new action

## ◆ setDestination()

void TPG::TPGActionEdge::setDestination | ( | TPGVertex * | newDestination | ) |
| override virtual

Override of the tpgEdge function because there should not be destination to action edge.

Reimplemented from TPG::TPGEdge.

The documentation for this class was generated from the following files:

- D:/a/gegelati/gegelati/gegelatilib/include/tpg/tpgActionEdge.h
- D:/a/gegelati/gegelati/gegelatilib/src/tpg/tpgActionEdge.cpp